## aoflagger 3.0.0

=== CMakeLists.txt ===
# AOFlagger 2.8 and higher use 'OBJECT' libraries and the 'TARGET_OBJECTS keywords. These
# require cmake 2.8.8.
cmake_minimum_required(VERSION 2.8.8)

project(AOFlagger)

include(CMakeVersionInfo.txt)
set(AOFLAGGER_VERSION "${AOFLAGGER_VERSION_MAJOR}.${AOFLAGGER_VERSION_MINOR}.${AOFLAGGER_VERSION_SUBMINOR}")

# Some CMake 'find package' files are stored in this directory
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

find_package(PkgConfig)
pkg_check_modules(GTKMM gtkmm-3.0>=3.0.0)
pkg_check_modules(SIGCXX sigc++-2.0)

include_directories(${CMAKE_SOURCE_DIR}/aocommon/include)

set(CASACORE_MAKE_REQUIRED_EXTERNALS_OPTIONAL TRUE)
find_package(Casacore REQUIRED COMPONENTS casa ms tables measures)

find_package(CFITSIO REQUIRED)

find_path(FFTW3_INCLUDE_DIR NAMES fftw3.h)

find_library(GSL_LIB NAMES gsl)
find_library(GSL_CBLAS_LIB NAMES gslcblas)
find_path(GSL_INCLUDE_DIR NAMES gsl/gsl_version.h)

find_package(Threads REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(PNG REQUIRED)
#Prevent accidentally finding old BoostConfig.cmake file from casapy
find_package(PythonLibs 3 REQUIRED)
find_package(PythonInterp REQUIRED)
message(STATUS "Using python version ${PYTHON_VERSION_STRING}")
find_package(pybind11 REQUIRED)

set(Boost_NO_BOOST_CMAKE ON)
# boost::alignment requires Boost 1.56
find_package(Boost 1.56.0 REQUIRED COMPONENTS date_time filesystem system unit_test_framework)
find_library(FFTW3_LIB fftw3 REQUIRED)
enable_language(Fortran OPTIONAL)
find_package(BLAS REQUIRED)
find_package(LAPACK REQUIRED)
find_package(Lua REQUIRED)

include_directories(${PYBIND11_INCLUDE_DIR})
include_directories(${CASACORE_INCLUDE_DIRS})
include_directories(${Boost_INCLUDE_DIR})
include_directories(${LIBXML2_INCLUDE_DIR})
include_directories(${CFITSIO_INCLUDE_DIR})
include_directories(${FFTW3_INCLUDE_DIR})
if(GSL_INCLUDE_DIR)
	include_directories(${GSL_INCLUDE_DIR})
endif(GSL_INCLUDE_DIR)
include_directories(${PYTHON_INCLUDE_DIRS})
include_directories(${LUA_INCLUDE_DIR})

# The following stuff will set the "rpath" correctly, so that
# LD_LIBRARY_PATH doesn't have to be set.

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH  FALSE)
# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
# the RPATH to be used when installing, but only if it's not a system directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
   set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif("${isSystemDir}" STREQUAL "-1")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror=vla -DNDEBUG -funroll-loops -O3 -std=c++11")

string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,--no-undefined")

include(CheckCXXCompilerFlag)
include(CheckSymbolExists) 
include(CheckCXXSymbolExists)
include(CheckIncludeFileCXX)

CHECK_SYMBOL_EXISTS(posix_fallocate "fcntl.h" HAVE_POSIX_FALLOCATE) 
CHECK_CXX_SYMBOL_EXISTS(exp10 "cmath" HAVE_EXP10)
if(HAVE_POSIX_FALLOCATE)
  add_definitions(-DHAVE_POSIX_FALLOCATE)
endif(HAVE_POSIX_FALLOCATE)

if(PORTABLE)
  message(STATUS "Portable build requested; a generic build will be created with slightly decreased performance.")
else()	
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
endif(PORTABLE)

if(GTKMM_FOUND)
  add_definitions(-DHAVE_GTKMM)
endif(GTKMM_FOUND)

if(GSL_LIB AND GSL_CBLAS_LIB AND GSL_INCLUDE_DIR)
  add_definitions(-DHAVE_GSL)
  link_libraries(${GSL_LIB} ${GSL_CBLAS_LIB})
  message(STATUS "GSL found.")
endif(GSL_LIB AND GSL_CBLAS_LIB AND GSL_INCLUDE_DIR)

configure_file(version.h.in version.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(AOQPLOT_FILES
  aoqplot/aoqplotwindow.cpp
  aoqplot/baselineplotpage.cpp
  aoqplot/datawindow.cpp
  aoqplot/grayscaleplotpage.cpp
  aoqplot/histogrampage.cpp
  aoqplot/timefrequencyplotpage.cpp
  aoqplot/twodimensionalplotpage.cpp
  aoqplot/controllers/aoqplotcontroller.cpp
  aoqplot/controllers/aoqplotpagecontroller.cpp
  aoqplot/controllers/baselinepagecontroller.cpp
  aoqplot/controllers/heatmappagecontroller.cpp
  aoqplot/controllers/histogrampagecontroller.cpp
  aoqplot/controllers/tfpagecontroller.cpp)

set(PLOT_FILES
  plot/colorscale.cpp
  plot/heatmapplot.cpp
  plot/horizontalplotscale.cpp
  plot/legend.cpp
  plot/plot2d.cpp
  plot/plotpropertieswindow.cpp
  plot/title.cpp
  plot/verticalplotscale.cpp)

set(GUI_FILES
  rfigui/controllers/imagecomparisoncontroller.cpp
  rfigui/controllers/rfiguicontroller.cpp
  rfigui/complexplaneplotwindow.cpp
  rfigui/gotowindow.cpp
  rfigui/imagepropertieswindow.cpp
  rfigui/heatmapwidget.cpp
  rfigui/msoptionwindow.cpp
  rfigui/plotframe.cpp
  rfigui/plotwindow.cpp
  rfigui/progresswindow.cpp
  rfigui/rfiguimenu.cpp
  rfigui/rfiguiwindow.cpp
  rfigui/settings.cpp
  rfigui/strategyeditor.cpp
  util/rfiplots.cpp
  util/multiplot.cpp
  ${PLOT_FILES} ${AOQPLOT_FILES})

set(IMAGING_FILES
  imaging/uvimager.cpp
  imaging/model.cpp)

set(INTERFACE_FILES
  interface/aoflagger.cpp
  interface/flagmask.cpp
  interface/imageset.cpp
  interface/qualitystatistics.cpp
  interface/strategy.cpp
  )
  
set(LUA_FILES
  lua/datawrapper.cpp
  lua/default-strategy.cpp
  lua/functions.cpp
  lua/functionswrapper.cpp
  lua/luastrategy.cpp
  lua/optionsfunction.cpp
  lua/scriptdata.cpp
  lua/telescopefile.cpp)
  
set(MSIO_FILES
  msio/baselinematrixloader.cpp
  msio/baselinereader.cpp
  msio/directbaselinereader.cpp
  msio/fitsfile.cpp
  msio/indirectbaselinereader.cpp
  msio/memorybaselinereader.cpp
  msio/multibanddata.cpp
  msio/msstatreader.cpp
  msio/pngfile.cpp
  msio/rspreader.cpp
  msio/singlebaselinefile.cpp
  msio/spatialtimeloader.cpp)
  
set(STRUCTURES_FILES
  structures/colormap.cpp
  structures/image2d.cpp
  structures/mask2d.cpp
  structures/msiterator.cpp
  structures/msmetadata.cpp
  structures/samplerow.cpp
  structures/stokesimager.cpp
  structures/timefrequencydata.cpp)
  
set(QUALITY_FILES
  quality/collector.cpp
  quality/histogramcollection.cpp
  quality/histogramtablesformatter.cpp
  quality/qualitytablesformatter.cpp
  quality/rayleighfitter.cpp
  quality/statisticscollection.cpp)

set(ALGORITHMS_FILES
  algorithms/antennaselector.cpp
  algorithms/baselineselector.cpp
	algorithms/baselinetimeplaneimager.cpp
  algorithms/combinatorialthresholder.cpp
  algorithms/fringestoppingfitter.cpp
  algorithms/fringetestcreater.cpp
	algorithms/highpassfilter.cpp
  algorithms/localfitmethod.cpp
  algorithms/morphology.cpp
  algorithms/sinusfitter.cpp
  algorithms/morphologicalflagger.cpp
  algorithms/sumthreshold.cpp
  algorithms/sumthresholdmissing.cpp
  algorithms/svdmitigater.cpp
  algorithms/testsetgenerator.cpp
  algorithms/thresholdconfig.cpp
  algorithms/thresholdtools.cpp
  algorithms/timefrequencystatistics.cpp)

set(PYTHON_FILES
  python/pythonstrategy.cpp
  python/pyfunctions.cpp)

set(IMAGESETS_FILES
  imagesets/bhfitsimageset.cpp
  imagesets/filterbankset.cpp
  imagesets/fitsimageset.cpp
  imagesets/imageset.cpp
  imagesets/msimageset.cpp
  imagesets/parmimageset.cpp
  imagesets/pngreader.cpp
  imagesets/rfibaselineset.cpp)

set(STRATEGY_FILES)

set(UTIL_FILES
  util/logger.cpp
  util/ffttools.cpp
  util/integerdomain.cpp
  util/plot.cpp
  util/rng.cpp
  util/stopwatch.cpp)

set(ALL_LIBRARIES
	${CASACORE_LIBRARIES}
	${FFTW3_LIB}
	${CFITSIO_LIBRARY}
	${PYTHON_LIBRARIES}
	${PNG_LIBRARIES} ${LIBXML2_LIBRARIES}
	${LUA_LIBRARIES}
	${Boost_LIBRARIES}
	${BLAS_LIBRARIES} ${LAPACK_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT})

if(GTKMM_FOUND)
	message(STATUS "GTKMM found.") 
	include_directories(${GTKMM_INCLUDE_DIRS})
	link_directories(${GTKMM_LIBDIR})
	set(ALL_LIBRARIES ${ALL_LIBRARIES} ${GTKMM_LIBRARIES})
endif(GTKMM_FOUND)

if(SIGCXX_FOUND)
	message(STATUS "SIGCXX found.") 
	include_directories(${SIGCXX_INCLUDE_DIRS})
	link_directories(${SIGCXX_LIBDIR})
	set(ALL_LIBRARIES ${ALL_LIBRARIES} ${SIGCXX_LIBRARIES})
endif(SIGCXX_FOUND)

if(GTKMM_FOUND)
	set(AOFLAGGER_PLOT_FILES ${PLOT_FILES})
endif(GTKMM_FOUND)

set(ALLFILES
  ${ALGORITHMS_FILES}
	${AOFLAGGER_PLOT_FILES}
  ${IMAGESETS_FILES}
	${IMAGING_FILES}
  ${INTERFACE_FILES}
	${LUA_FILES}
	${MSIO_FILES}
  ${PYTHON_FILES}
	${QUALITY_FILES}
	${STRUCTURES_FILES}
	${UTIL_FILES}
)
add_library(aoflagger-lib SHARED ${ALLFILES})
set_target_properties(aoflagger-lib PROPERTIES SOVERSION 0)
set_target_properties(aoflagger-lib PROPERTIES OUTPUT_NAME aoflagger)
target_link_libraries(aoflagger-lib ${ALL_LIBRARIES})
install (TARGETS aoflagger-lib DESTINATION lib) 

add_executable(aoquality applications/aoquality.cpp)
target_link_libraries(aoquality aoflagger-lib ${ALL_LIBRARIES})
install (TARGETS aoquality DESTINATION bin)

if(GTKMM_FOUND)
	add_library(aoflaggergui OBJECT ${GUI_FILES})
	set(AOFLAGGERGUI_OBJECT $<TARGET_OBJECTS:aoflaggergui>)
  add_executable(rfigui applications/rfigui.cpp ${AOFLAGGERGUI_OBJECT})
  target_link_libraries(rfigui aoflagger-lib ${ALL_LIBRARIES})
	install (TARGETS rfigui DESTINATION bin)
  
	add_executable(aoqplot applications/aoqplot.cpp ${AOFLAGGERGUI_OBJECT})
  target_link_libraries(aoqplot aoflagger-lib ${ALL_LIBRARIES})
 	install (TARGETS aoqplot DESTINATION bin)
	
	add_executable(badstations applications/badstations.cpp)
	target_link_libraries(badstations aoflagger-lib ${ALL_LIBRARIES})
  
else()
  message(WARNING " The graphical user interface library GTKMM was not found; rfigui and aoqplot will not be compiled.")
endif(GTKMM_FOUND)

add_executable(aoflagger-bin
	applications/aoflagger.cpp
	aoluarunner/options.cpp 
	aoluarunner/runner.cpp aoluarunner/baselineiterator.cpp aoluarunner/writethread.cpp)
set_target_properties(aoflagger-bin PROPERTIES OUTPUT_NAME aoflagger)
target_link_libraries(aoflagger-bin aoflagger-lib ${ALL_LIBRARIES})
install (TARGETS aoflagger-bin DESTINATION bin)

add_executable(runtests EXCLUDE_FROM_ALL
	test/runtests.cpp
	
	test/experiments/defaultstrategyspeedtest.cpp
	test/experiments/highpassfilterexperiment.cpp
	
	test/lua/defaultstrategytest.cpp
	test/lua/optionsfunctiontest.cpp
	test/lua/telescopefiletest.cpp
	
	test/interface/interfacetest.cpp
	
	test/quality/qualitytablesformattertest.cpp
	test/quality/statisticscollectiontest.cpp
	test/quality/statisticsderivatortest.cpp
	
	test/algorithms/convolutionstest.cpp
	test/algorithms/dilationtest.cpp
	test/algorithms/highpassfiltertest.cpp
	test/algorithms/noisestatisticstest.cpp
	test/algorithms/siroperatortest.cpp
	test/algorithms/sumthresholdmissingtest.cpp
	test/algorithms/sumthresholdtest.cpp
	test/algorithms/thresholdtoolstest.cpp
		
	test/structures/image2dtest.cpp
	test/structures/timefrequencydatatest.cpp
	
	test/util/numberparsertest.cpp
	
)
target_link_libraries(runtests aoflagger-lib ${ALL_LIBRARIES})

add_test(runtests runtests)
add_custom_target(check COMMAND runtests DEPENDS runtests)

install (FILES interface/aoflagger.h DESTINATION include)
install (DIRECTORY data/icons data/applications DESTINATION share )
install (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/data/strategies DESTINATION share/aoflagger FILES_MATCHING PATTERN *.lua)

# Set-up cmake configuration files
configure_file(
    "${PROJECT_SOURCE_DIR}/cmake/config/aoflagger-config.cmake.in"
    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config.cmake" @ONLY)
configure_file(
    "${PROJECT_SOURCE_DIR}/cmake/config/aoflagger-config-version.cmake.in"
    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config-version.cmake" @ONLY)

install(FILES
    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config.cmake"
    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config-version.cmake"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/aoflagger/cmake)

add_subdirectory(python)

add_custom_target(sphinxdoc
  make html
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc

=== debian/changelog ===
aoflagger (3.0.0-2) unstable; urgency=medium

  * Add missing header file to fix FTBFS on non-x86 platforms

 -- Ole Streicher <olebole@debian.org>  Wed, 19 Aug 2020 15:30:15 +0200

aoflagger (3.0.0-1) unstable; urgency=medium

  * Adjust d/watch for new upstream repository
  * New upstream version 3.0.0. Rediff patches. Closes: #966866
  * Disable test cases that don't work before installation
  * Adjust installed files list and build dependencies

 -- Ole Streicher <olebole@debian.org>  Wed, 19 Aug 2020 14:36:10 +0200

aoflagger (2.15.0-3) unstable; urgency=medium

  * Improve finding of Boost Python (Closes: #962390, #956580)

 -- Ole Streicher <olebole@debian.org>  Fri, 12 Jun 2020 14:02:42 +0200

aoflagger (2.15.0-2) unstable; urgency=medium

  * Remove libboost-signals-dev (Closes: #960331)
  * Pin libboost build deps to 1.67 as workaround for #956580

 -- Ole Streicher <olebole@debian.org>  Wed, 03 Jun 2020 15:44:09 +0200

aoflagger (2.15.0-1) unstable; urgency=low

  * Add gitlab-ci.yml for salsa
  * New upstream version 2.15.0
  * Drop patches that were applied upstream
  * Push Standards-Version to 4.5.0. No changes required
  * New build dependency liblua5.3-dev
  * Remove static lib from aoflagger-dev

 -- Ole Streicher <olebole@debian.org>  Wed, 26 Feb 2020 08:55:10 +0100

=== debian/control ===
Source: aoflagger
Section: science
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
Build-Depends: casacore-dev,
               cmake,
               debhelper-compat (= 12),
               doxygen,
               gfortran,
               graphviz,
               libblas-dev,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libcfitsio-dev,
               libfftw3-dev,
               libgtkmm-3.0-dev,
               liblapack-dev,
               liblua5.3-dev,
               libpng-dev,
               libpython3-dev,
               libxml2-dev,
               pybind11-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian-astro-team/aoflagger.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/aoflagger
Homepage: https://sourceforge.net/projects/aoflagger/
Rules-Requires-Root: no

Package: aoflagger
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: aoflagger-dev
Description: Find RFI in radio astronomical observations
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 Besides the flagger, the software consists of tools to efficiently visualize
 data in different ways, such as plotting time-frequency diagrams and power
 spectra. It provides the programs aoflagger, rfigui, aoqplot, aoquality and
 more.

Package: libaoflagger0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Find RFI in radio astronomical observations (shared lib)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains the shared library.

Package: aoflagger-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libaoflagger0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: aoflagger
Description: Find RFI in radio astronomical observations (development files)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains the header file to compile own programs against
 the library.

## aoflagger 3.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,47 +14,64 @@
 pkg_check_modules(GTKMM gtkmm-3.0>=3.0.0)
 pkg_check_modules(SIGCXX sigc++-2.0)
 
-include_directories(${CMAKE_SOURCE_DIR}/aocommon/include)
+# Find and include git submodules
+find_package(Git QUIET)
+if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
+# Update submodules as needed
+    option(GIT_SUBMODULE "Check submodules during build" ON)
+    if(GIT_SUBMODULE)
+        message(STATUS "Submodule update")
+        execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive --checkout
+                        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+                        RESULT_VARIABLE GIT_SUBMOD_RESULT)
+        if(NOT GIT_SUBMOD_RESULT EQUAL "0")
+            message(FATAL_ERROR "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
+        endif()
+    endif()
+endif()
+
+# Include aocommon/pybind11 headers
+include_directories("${CMAKE_SOURCE_DIR}/aocommon/include")
+add_subdirectory("${CMAKE_SOURCE_DIR}/external/pybind11")
+include_directories(${pybind11_INCLUDE_DIR})
 
 set(CASACORE_MAKE_REQUIRED_EXTERNALS_OPTIONAL TRUE)
 find_package(Casacore REQUIRED COMPONENTS casa ms tables measures)
+include_directories(${CASACORE_INCLUDE_DIRS})
 
 find_package(CFITSIO REQUIRED)
+include_directories(${CFITSIO_INCLUDE_DIR})
 
 find_path(FFTW3_INCLUDE_DIR NAMES fftw3.h)
 
 find_library(GSL_LIB NAMES gsl)
 find_library(GSL_CBLAS_LIB NAMES gslcblas)
 find_path(GSL_INCLUDE_DIR NAMES gsl/gsl_version.h)
+if(GSL_INCLUDE_DIR)
+  include_directories(${GSL_INCLUDE_DIR})
+endif(GSL_INCLUDE_DIR)
 
 find_package(Threads REQUIRED)
 find_package(LibXml2 REQUIRED)
+include_directories(${LIBXML2_INCLUDE_DIR})
+
 find_package(PNG REQUIRED)
-#Prevent accidentally finding old BoostConfig.cmake file from casapy
 find_package(PythonLibs 3 REQUIRED)
 find_package(PythonInterp REQUIRED)
 message(STATUS "Using python version ${PYTHON_VERSION_STRING}")
-find_package(pybind11 REQUIRED)
-
-set(Boost_NO_BOOST_CMAKE ON)
+include_directories(${PYTHON_INCLUDE_DIRS})
+
 # boost::alignment requires Boost 1.56
 find_package(Boost 1.56.0 REQUIRED COMPONENTS date_time filesystem system unit_test_framework)
+include_directories(${Boost_INCLUDE_DIR})
+
 find_library(FFTW3_LIB fftw3 REQUIRED)
+include_directories(${FFTW3_INCLUDE_DIR})
+
 enable_language(Fortran OPTIONAL)
 find_package(BLAS REQUIRED)
 find_package(LAPACK REQUIRED)
-find_package(Lua REQUIRED)
-
-include_directories(${PYBIND11_INCLUDE_DIR})
-include_directories(${CASACORE_INCLUDE_DIRS})
-include_directories(${Boost_INCLUDE_DIR})
-include_directories(${LIBXML2_INCLUDE_DIR})
-include_directories(${CFITSIO_INCLUDE_DIR})
-include_directories(${FFTW3_INCLUDE_DIR})
-if(GSL_INCLUDE_DIR)
-	include_directories(${GSL_INCLUDE_DIR})
-endif(GSL_INCLUDE_DIR)
-include_directories(${PYTHON_INCLUDE_DIRS})
+find_package(Lua 5.2 REQUIRED)
 include_directories(${LUA_INCLUDE_DIR})
 
 # The following stuff will set the "rpath" correctly, so that
@@ -77,8 +94,11 @@
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror=vla -DNDEBUG -funroll-loops -O3 -std=c++11")
 
-string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,--no-undefined")
-
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+  message(STATUS "Debug build selected: setting linking flag --no-undefined")
+  string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,--no-undefined")
+endif()
+  
 include(CheckCXXCompilerFlag)
 include(CheckSymbolExists) 
 include(CheckCXXSymbolExists)
@@ -142,6 +162,7 @@
   rfigui/imagepropertieswindow.cpp
   rfigui/heatmapwidget.cpp
   rfigui/msoptionwindow.cpp
+  rfigui/opendialog.cpp
   rfigui/plotframe.cpp
   rfigui/plotwindow.cpp
   rfigui/progresswindow.cpp
@@ -236,6 +257,7 @@
   imagesets/filterbankset.cpp
   imagesets/fitsimageset.cpp
   imagesets/imageset.cpp
+  imagesets/indexableset.cpp
   imagesets/msimageset.cpp
   imagesets/parmimageset.cpp
   imagesets/pngreader.cpp
@@ -336,6 +358,8 @@
 	test/experiments/highpassfilterexperiment.cpp
 	
 	test/lua/defaultstrategytest.cpp
+	test/lua/flagnanstest.cpp
+	test/lua/tmetadata.cpp
 	test/lua/optionsfunctiontest.cpp
 	test/lua/telescopefiletest.cpp
 	
@@ -356,6 +380,8 @@
 		
 	test/structures/image2dtest.cpp
 	test/structures/timefrequencydatatest.cpp
+	test/structures/tmask2d.cpp
+	test/structures/tversionstring.cpp
 	
 	test/util/numberparsertest.cpp
 	
@@ -363,27 +389,3 @@
 target_link_libraries(runtests aoflagger-lib ${ALL_LIBRARIES})
 
 add_test(runtests runtests)
-add_custom_target(check COMMAND runtests DEPENDS runtests)
-
-install (FILES interface/aoflagger.h DESTINATION include)
-install (DIRECTORY data/icons data/applications DESTINATION share )
-install (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/data/strategies DESTINATION share/aoflagger FILES_MATCHING PATTERN *.lua)
-
-# Set-up cmake configuration files
-configure_file(
-    "${PROJECT_SOURCE_DIR}/cmake/config/aoflagger-config.cmake.in"
-    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config.cmake" @ONLY)
-configure_file(
-    "${PROJECT_SOURCE_DIR}/cmake/config/aoflagger-config-version.cmake.in"
-    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config-version.cmake" @ONLY)
-
-install(FILES
-    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config.cmake"
-    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config-version.cmake"
-    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/aoflagger/cmake)
-
-add_subdirectory(python)
-
-add_custom_target(sphinxdoc
-  make html
-  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc

=== aocommon/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)

project(aocommon)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11 -ggdb")

# add target to generate API documentation with Doxygen
find_package(Threads REQUIRED)
find_package(Doxygen)

if(DOXYGEN_FOUND)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
add_custom_target(doc
  ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating API documentation with Doxygen" VERBATIM)
endif(DOXYGEN_FOUND)

find_package(Boost COMPONENTS unit_test_framework REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

add_executable(runtests 
  tests/runtests.cpp
  tests/tparallelfor.cpp
  tests/tthreadpool.cpp
  tests/tuvector.cpp
  )
target_link_libraries(runtests ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} )

add_custom_target(
  execute_runtests_target ALL
  DEPENDS execute_runtests
)
add_custom_command(OUTPUT execute_runtests COMMAND runtests DEPENDS runtests)

message(STATUS "Flags passed to C++ compiler: " ${CMAKE_CXX_FLAGS})

=== cpack/CMakeLists.txt ===
# Copyright (C) 2020 ASTRON (Netherlands Institute for Radio Astronomy)
# SPDX-License-Identifier: GPL-3.0-or-later

set(CPACK_PACKAGE_NAME "AOFlagger")
set(CPACK_PACKAGE_VENDOR "ASTRON")
set(CPACK_PACKAGE_VERSION_MAJOR "${AOFLAGGER_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${AOFLAGGER_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${AOFLAGGER_VERSION_SUBMINOR}")
set(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Find RFI in radio astronomical observations")
set(CPACK_PACKAGE_HOMEPAGE_URL "https://gitlab.com/aroffringa/aoflagger/")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")

set(CPACK_GENERATOR "DEB")
set(CPACK_SOURCE_GENERATOR "TGZ")

set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "deb-packages@astron.nl")
set(CPACK_DEBIAN_PACKAGE_SECTION "science")
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)

include(CPack)

=== python/CMakeLists.txt ===
pybind11_add_module(python_aoflagger MODULE pyinterface.cpp pyfunctions.cpp)

set_target_properties(python_aoflagger PROPERTIES SOVERSION 0)
set_target_properties(python_aoflagger PROPERTIES OUTPUT_NAME "aoflagger")
target_link_libraries(python_aoflagger PUBLIC aoflagger-lib PUBLIC ${ALL_LIBRARIES})
install (TARGETS python_aoflagger DESTINATION lib)

=== debian/changelog ===
aoflagger (3.1.0-2build3) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 15 Jan 2022 08:33:12 +0000

aoflagger (3.1.0-2build2) jammy; urgency=medium

  * No-change rebuild against current libglibmm-2.4-1v5.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Dec 2021 02:20:07 +0000

aoflagger (3.1.0-2build1) jammy; urgency=medium

  * No-change rebuild against current libglibmm-2.4-1v5.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 02:03:53 +0000

aoflagger (3.1.0-2) unstable; urgency=medium

  * Make compile with gcc11 (Closes: #983967)

 -- Ole Streicher <olebole@debian.org>  Mon, 01 Nov 2021 10:09:56 +0100

aoflagger (3.1.0-1) unstable; urgency=medium

  * New upstream version 3.1.0
  * Rediff patches
  * Push Standards-Version to 4.6.0. No changes needed
  * Update build dependencies
  * Use system provided pybind11
  * Push dh-compat to 13. Create d/not-installed

 -- Ole Streicher <olebole@debian.org>  Mon, 30 Aug 2021 15:05:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,20 @@
 Source: aoflagger
 Section: science
 Priority: optional
-Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
 Build-Depends: casacore-dev,
                cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                doxygen,
                gfortran,
                graphviz,
                libblas-dev,
                libboost-date-time-dev,
-               libboost-dev,
                libboost-filesystem-dev,
                libboost-system-dev,
                libboost-test-dev,
-               libboost-thread-dev,
                libcfitsio-dev,
                libfftw3-dev,
                libgtkmm-3.0-dev,
@@ -25,8 +24,9 @@
                libpython3-dev,
                libxml2-dev,
                pybind11-dev,
+               python3-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/debian-astro-team/aoflagger.git
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/aoflagger
 Homepage: https://sourceforge.net/projects/aoflagger/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

ifeq ($(DEB_HOST_ARCH_CPU),i386)
    export DEB_CXXFLAGS_MAINT_APPEND = -ffloat-store
endif

CMAKE_FLAGS += -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` -DPORTABLE=yes

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)
